;------------------------------------------------------------
;AZuIvV
;------------------------------------------------------------
VX4:	EQU	1	;VX-4
VX3:	EQU	2	;VX-3
MODEL:	EQU	VX4

#if MODEL=VX4
;------------------------------------------------------------
; WORK AREA
;------------------------------------------------------------
EDCSR:	EQU	&H1101	;J[\ʒu
FDDBF:	EQU	&H1793	;FDDo̓obt@
RSFG:	EQU	&H173E	;RS232CpftHgl
MEMEN:	EQU	&H18CF	;t[GA擪|C^
DIREN:	EQU	&H18D1	;RAM(DIR)ŏI|C^
CALC:	EQU	&H18D3	;CALCpobt@
JPTBL:	EQU	&H19C9	;oCit@CsAhX
DEFDIR:	EQU	&H2FFF	;DIRENl

;------------------------------------------------------------
; BIOS Routine
;------------------------------------------------------------
CHEX1:	EQU	&H009D	;16i-->oCiϊ
CROFF:	EQU	&H032E	;J[\OFF(KYIÑJ[\\OFFɂ)
KYIN:	EQU	&H03A4	;WL[͏i$0ɓ͂ꂽL[R[hj
FREE:	EQU	&H20E2	;FREEGAeʂ\
CLS:	EQU	&H2ADF	;ʏ(PRINT CHR$(12)Ɠ)
OUTAC:	EQU	&H2AF1	;1\(o͐OUTDVɂĎw)
OMERR:	EQU	&H2B6D	;OM Error
RWERR:	EQU	&H2B84	;RW Error
BIOS:	EQU	&H5321	;BIOS(BANK0)R[BANK1ɖ߂
RSOPN:	EQU	&H84EC	;RS232C OPEN
RSCLO:	EQU	&H8563	;RS232C CLOSE
RSGET:	EQU	&H8590	;RS232C 1oCgM
PRTRS:	EQU	&H85FB	;RS232C M

#else
;------------------------------------------------------------
; WORK AREA
;------------------------------------------------------------
EDCSR:	EQU	&H6101	;J[\ʒu
RSFG:	EQU	&H6737	;RS232CftHgl
FDDBF:	EQU	&H678C	;FDDo̓obt@
MEMEN:	EQU	&H68C8	;t[GA擪|C^
DIREN:	EQU	&H68CA	;RAM(DIR)ŏI|C^
CALC:	EQU	&H68CC	;CALCpobt@
JPTBL:	EQU	&H69C1	;oCit@CsAhX
DEFDIR:	EQU	&H7FFF	;DIRENl

;------------------------------------------------------------
; BIOS Routine
;------------------------------------------------------------
CHEX1:	EQU	&H0125	;16i-->oCiϊ
KYIN:	EQU	&H03D1	;WL[͏i$0ɓ͂ꂽL[R[hj
CROFF:	EQU	&H1FAE	;J[\ON(KYIÑJ[\\OFFɂ)
RSOPN:	EQU	&H2535	;RS232C OPEN
RSCLO:	EQU	&H2582	;RS232C CLOSE
RSGET:	EQU	&H25B6	;RS232C 1oCgM
PRTRS:	EQU	&H2621	;RS232C M
FREE:	EQU	&H2858	;FREEGAeʂ\
CLS:	EQU	&H31CF	;ʏ(PRINT CHR$(12)Ɠ)
OUTAC:	EQU	&H31E1	;$161\(o͐OUTDVɂĎw)
OMERR:	EQU	&H325D	;OM Error
RWERR:	EQU	&H3274	;RW Error
RSEN:	EQU	&H4E19	;RS232CMH/W(MRSOPNOɎs/VX-3̂)
BIOS:	EQU	&H5CA7	;BIOS(BANK0)R[BANK1ɖ߂
#endif

	ORG	FDDBF

PBF2BIN:
#if MODEL=VX3
	LDW	$28,RSEN	;RS232CMH/W
	CAL	RCS		;(VX-3̂)
#endif
	PRE	IX,RSFG		;F.COMftHglǂݍ
	LDM	$11,(IX+$31),3	;
	LD	$0,2		;Mw
	LDW	$28,RSOPN	;RS232C OPEN
	CAL	RCS		;

GETFNL:	CAL	XGET		;1M($0)
	JR	NZ,GETFNL	;t@Cǂݔ΂

GETADR:	CAL	GETDEC		;JnAhX擾
	LDW	$6,$20		;JnAhX$10,$11ɕۑ

	PRE	IX,MEMEN	;FREEGA`FbN(TOP)
	SBCW	(IX+$31),$6	;(MEMEN)ƊJnAhXr
	JR	NC,OMERROR	;

	SBW	$6,$30		;JnAhX - 1$6,$7ɕۑ
	LDW	$26,$6		;$6,$7$26,$27ɃRs[

	CAL	GETDEC		;IAhX擾
	LDW	$8,$20		;IAhX$8,$9ɕۑ

	SBCW	$24,$8		;FREEGA`FbN(BOTTOM)
	JR	C,OMERROR	;DEFDIRƏIAhXr

	CAL	GETDEC		;sAhX擾
	LDW	$10,$20		;sAhX$10,$11ɕۑ

	LD	$14,&H83	;o̓[h
	LDW	$15,&H03D2	;Ww
	LDW	$17,&HE060	;R[hݒ

PBFLP0:	XRW	$12,$12		;`FbNT

PBFLP1:	ANC	$6,&H3F		;16oCgMɕ\
	JR	LNZ,PBFLP2	;

	PPO	&HC7		;LCDR}hWX^w肷 
	STLM	$14,3		;(R}hݒ) 
	PPO	&HC6		;LCDf[^ݎw
	STL	$17		;1\

	XR	$17,$18		;60H->80H->70H->90H->60H
	XR	$18,&H10	;

PBFLP2:	CAL	XGET		;1M($0)
	JR	Z,GETSUM	;J}/CRMȂ`FbNTmF
	CAL	ASC2BIN		;ASCII-->BINϊ

	DIU	$0		;グ
	LD	$5,$0		;

	CAL	RCV		;1M($0)
	CAL	ASC2BIN		;ASCII-->BINϊ

	OR	$0,$5		;Mf[^쐬
	LD	$1,$31		;(ʌNA)

	ADW	$6,$30		;AhXXV
	ST	$0,($6)		;f[^i[
	ADW	$12,$0		;`FbNTvZ

	SBCW	$8,$6		;f[^i[AhXI?
	JR	NZ,PBFLP1	;

	CAL	RCV		;J}ǂݔ΂

GETSUM:	CAL	GETDEC		;`FbNTM
	SBCW	$12,$20		;`FbNTُ?
	JR	NZ,RWERROR	;

	SBCW	$8,$6		;f[^i[I?
	JR	NZ,PBFLP0	;

	STW	$26,($22)	;DIRENXV
	PRE	IX,JPTBL	;JPTBLɎsAhX
	STW	$10,(IX+$30)	;

RSCLOSE:LDW	$28,RSCLO	;RS232CN[Y
	JR	RCS		;

;------------------------------------------------------------
; OM ErrorI
;------------------------------------------------------------
OMERROR:CAL	RSCLOSE		;RS232CN[Y
	PST	UA,&H54		;OM errorI
	JP	OMERR		;

;------------------------------------------------------------
; AXL[R[h16if[^ɕϊ
;  $0
; o $0iϊf[^j
;------------------------------------------------------------
ASC2BIN:LDW	$28,CHEX1	;ASCIIoCiϊ
	JR	RCS		;

;------------------------------------------------------------
; GETDEC(10iM)
; RS232CoR10iM
; ́F
; óF$20,$21 -- Ml
;       ZF ------- Z:J}/CRM NZ:ʏ핶M
;------------------------------------------------------------
GETDEC:	XRW	$20,$20		;Mf[^

GETDECL:CAL	XGET		;RS232C1M
	RTN	Z		;J}/CRMɂďI

	SB	$0,"0"		;10ilϊ

	BIUW	$20		;10{쐬
	LDW	$2,$20		;(2{)
	BIUW	$20		;
	BIUW	$20		;(8{)
	ADW	$20,$2		;(2{+8{)

	LD	$1,$31		;
	ADW	$20,$0		;MlJ荞
	JR	NC,GETDECL

;------------------------------------------------------------
; RW ErrorI
;------------------------------------------------------------
RWERROR:CAL	RSCLOSE		;RS232CN[Y
	PST	UA,&H54		;RW error I
	JP	RWERR		;

;------------------------------------------------------------
; XGET(1M)
; RS232CoR1M
; ́FȂ
; óF$0 --- Ml
;       ZF --- Z:J}/CRM NZ:ʏ핶M
;------------------------------------------------------------
XGET:	CAL	RCV		;1M($0)
	SBC	$0,&H0A		;LFM͖
	JR	Z,XGET		;

	SBC	$0,","		;J}MɂďI
	RTN	Z		;

	SBC	$0,&H0D		;CRM`FbN(tOĂ)
	RTN

;------------------------------------------------------------
; RS232C 1oCgM
;------------------------------------------------------------
RCV:	LDW	$28,RSGET	;XON/XOFFɂ1oCgM

;------------------------------------------------------------
; BIOSĂяo
; ́F$28,$29 --- BIOSĂяoAhX
;------------------------------------------------------------
RCS:	PST	UA,&H54		;BIOSĂяo
	JP	BIOS		;
